diff mbox

xfstests: btrfs/015 regression test for prealloc with balance

Message ID 1380292053-8123-1-git-send-email-jbacik@fusionio.com (mailing list archive)
State Not Applicable
Headers show

Commit Message

Josef Bacik Sept. 27, 2013, 2:27 p.m. UTC
We had a regression where we were not copying csums properly when balancing a
prealloc extent.  Unfortunately the way this showed up the most was with the
csum simply missing, which doesn't result in an error to userspace.  So I've
copied what generic/310 does and check dmesg for csum errors when the test
starts and then compare that count to the csum errors after the test finishes to
see if there was a problem.  This approach caught the error without my fix, and
then passed fine with my fix in place but with the previous errors still in
dmesg.  Thanks,

Signed-off-by: Josef Bacik <jbacik@fusionio.com>
---
 tests/btrfs/015     | 87 +++++++++++++++++++++++++++++++++++++++++++++++++++++
 tests/btrfs/015.out |  2 ++
 tests/btrfs/group   |  1 +
 3 files changed, 90 insertions(+)
 create mode 100644 tests/btrfs/015
 create mode 100644 tests/btrfs/015.out

Comments

Stefan Behrens Sept. 27, 2013, 3:52 p.m. UTC | #1
On Fri, 27 Sep 2013 10:27:33 -0400, Josef Bacik wrote:
> We had a regression where we were not copying csums properly when balancing a
> prealloc extent.  Unfortunately the way this showed up the most was with the
> csum simply missing, which doesn't result in an error to userspace.  So I've
> copied what generic/310 does and check dmesg for csum errors when the test
> starts and then compare that count to the csum errors after the test finishes to
> see if there was a problem.  This approach caught the error without my fix, and
> then passed fine with my fix in place but with the previous errors still in
> dmesg.  Thanks,
> 
> Signed-off-by: Josef Bacik <jbacik@fusionio.com>
> ---
>  tests/btrfs/015     | 87 +++++++++++++++++++++++++++++++++++++++++++++++++++++
>  tests/btrfs/015.out |  2 ++
>  tests/btrfs/group   |  1 +
>  3 files changed, 90 insertions(+)
>  create mode 100644 tests/btrfs/015
>  create mode 100644 tests/btrfs/015.out
> 
> diff --git a/tests/btrfs/015 b/tests/btrfs/015
> new file mode 100644
> index 0000000..d463e48
> --- /dev/null
> +++ b/tests/btrfs/015
> @@ -0,0 +1,87 @@
> +#! /bin/bash
> +# FS QA Test No. btrfs/015
> +#
> +# Regression test for balance with prealloc extents.  This checks to make sure
> +# we are balacing prealloc'ed extents properly by making sure we don't have any
> +# csum errors.  Unfortunately this manifests itself with no csum which means
> +# userspace doesn't get an error when reading the file back so we have to grok
> +# dmesg to see if there was a csum error.
> +#
> +#-----------------------------------------------------------------------
> +# Copyright (c) 2013 Fusion IO.  All Rights Reserved.
> +#
> +# This program is free software; you can redistribute it and/or
> +# modify it under the terms of the GNU General Public License as
> +# published by the Free Software Foundation.
> +#
> +# This program is distributed in the hope that it would be useful,
> +# but WITHOUT ANY WARRANTY; without even the implied warranty of
> +# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
> +# GNU General Public License for more details.
> +#
> +# You should have received a copy of the GNU General Public License
> +# along with this program; if not, write the Free Software Foundation,
> +# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
> +#
> +#-----------------------------------------------------------------------
> +#
> +
> +seq=`basename $0`
> +seqres=$RESULT_DIR/$seq
> +echo "QA output created by $seq"
> +
> +here=`pwd`
> +tmp=/tmp/$$
> +
> +status=1	# failure is the default!
> +
> +_cleanup()
> +{
> +	rm -f $tmp.*
> +}
> +
> +trap "_cleanup ; exit \$status" 0 1 2 3 15
> +
> +# get standard environment, filters and checks
> +. ./common/rc
> +. ./common/filter
> +
> +# real QA test starts here
> +_supported_fs btrfs
> +_supported_os Linux
> +_require_scratch
> +
> +rm -f $seqres.full
> +
> +_scratch_mkfs > /dev/null 2>&1
> +_scratch_mount
> +
> +nr_csum_no_found=$(dmesg | grep -c "no csum found")
> +nr_csum_failed=$(dmesg | grep -c "csum failed")
> +
> +_check_csum_error()
> +{
> +	new_csum_no_found=$(dmesg | grep -c "no csum found")
> +	new_csum_failed=$(dmesg | grep -c "csum failed")
> +
> +	if [ $nr_csum_no_found -eq $new_csum_no_found -a \
> +	     $nr_csum_failed -eq $new_csum_failed ]; then
> +		return 0
> +	fi
> +	return 1
> +}
> +$XFS_IO_PROG -f -c "falloc 0 1M" -c "pwrite 16k 8k" -c "fsync" \
> +	$SCRATCH_MNT/foo > $seqres.full 2>&1
> +$BTRFS_UTIL_PROG fi ba $SCRATCH_MNT >> $seqres.full 2>&1 || \
> +	_fail "balance failed"
> +_scratch_unmount
> +_scratch_mount
> +$XFS_IO_PROG -c "pread 0 1M" $SCRATCH_MNT/foo >> $seqres.full 2>&1 || \
> +	_fail "pread failed"
> +
> +# This sucks but unfortunately it is the only way to be sure something didn't go
> +# wrong.
> +_check_csum_error || _fail "csum detected, please check dmesg"
> +
> +echo "Silence is golden"
> +status=0 ; exit
> diff --git a/tests/btrfs/015.out b/tests/btrfs/015.out
> new file mode 100644
> index 0000000..fee0fcf
> --- /dev/null
> +++ b/tests/btrfs/015.out
> @@ -0,0 +1,2 @@
> +QA output created by 015
> +Silence is golden
> diff --git a/tests/btrfs/group b/tests/btrfs/group
> index 3a5747f..dc5bbea 100644
> --- a/tests/btrfs/group
> +++ b/tests/btrfs/group
> @@ -17,3 +17,4 @@
>  012 auto quick
>  013 auto quick
>  014 auto quick
> +015 auto quick
> 

Nothing to complain about.

Reviewed-by: Stefan Behrens <sbehrens@giantdisaster.de>


--
To unsubscribe from this list: send the line "unsubscribe linux-btrfs" in
the body of a message to majordomo@vger.kernel.org
More majordomo info at  http://vger.kernel.org/majordomo-info.html
Zach Brown Sept. 27, 2013, 5:55 p.m. UTC | #2
> +nr_csum_no_found=$(dmesg | grep -c "no csum found")
> +nr_csum_failed=$(dmesg | grep -c "csum failed")
> +
> +_check_csum_error()
> +{
> +	new_csum_no_found=$(dmesg | grep -c "no csum found")
> +	new_csum_failed=$(dmesg | grep -c "csum failed")
> +
> +	if [ $nr_csum_no_found -eq $new_csum_no_found -a \
> +	     $nr_csum_failed -eq $new_csum_failed ]; then
> +		return 0
> +	fi
> +	return 1
> +}

> +# This sucks but unfortunately it is the only way to be sure something didn't go
> +# wrong.
> +_check_csum_error || _fail "csum detected, please check dmesg"

In the future you could make them trace events and catch them for a
given invocation of a command with perf.

- z
--
To unsubscribe from this list: send the line "unsubscribe linux-btrfs" in
the body of a message to majordomo@vger.kernel.org
More majordomo info at  http://vger.kernel.org/majordomo-info.html
David Sterba Oct. 1, 2013, 2:25 p.m. UTC | #3
On Fri, Sep 27, 2013 at 10:27:33AM -0400, Josef Bacik wrote:
> +$BTRFS_UTIL_PROG fi ba $SCRATCH_MNT >> $seqres.full 2>&1 || \
> +	_fail "balance failed"

Please use the full command names, also 'filesystem balance' is the
obsolete form, it's spelled 'btrfs balance start'.

david
--
To unsubscribe from this list: send the line "unsubscribe linux-btrfs" in
the body of a message to majordomo@vger.kernel.org
More majordomo info at  http://vger.kernel.org/majordomo-info.html
Rich Johnston Oct. 16, 2013, 8:18 p.m. UTC | #4
This has been committed.

Thanks
--Rich

NOTE: the test was renumbered to the next test number.

commit 5956d1dd653decd08dd323a4be8b1c3cc40eb673
Author: Josef Bacik <jbacik@fusionio.com>
Date:   Fri Sep 27 14:27:33 2013 +0000

     xfstests: btrfs/013 regression test for prealloc with balance

--
To unsubscribe from this list: send the line "unsubscribe linux-btrfs" in
the body of a message to majordomo@vger.kernel.org
More majordomo info at  http://vger.kernel.org/majordomo-info.html
diff mbox

Patch

diff --git a/tests/btrfs/015 b/tests/btrfs/015
new file mode 100644
index 0000000..d463e48
--- /dev/null
+++ b/tests/btrfs/015
@@ -0,0 +1,87 @@ 
+#! /bin/bash
+# FS QA Test No. btrfs/015
+#
+# Regression test for balance with prealloc extents.  This checks to make sure
+# we are balacing prealloc'ed extents properly by making sure we don't have any
+# csum errors.  Unfortunately this manifests itself with no csum which means
+# userspace doesn't get an error when reading the file back so we have to grok
+# dmesg to see if there was a csum error.
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2013 Fusion IO.  All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+
+status=1	# failure is the default!
+
+_cleanup()
+{
+	rm -f $tmp.*
+}
+
+trap "_cleanup ; exit \$status" 0 1 2 3 15
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+# real QA test starts here
+_supported_fs btrfs
+_supported_os Linux
+_require_scratch
+
+rm -f $seqres.full
+
+_scratch_mkfs > /dev/null 2>&1
+_scratch_mount
+
+nr_csum_no_found=$(dmesg | grep -c "no csum found")
+nr_csum_failed=$(dmesg | grep -c "csum failed")
+
+_check_csum_error()
+{
+	new_csum_no_found=$(dmesg | grep -c "no csum found")
+	new_csum_failed=$(dmesg | grep -c "csum failed")
+
+	if [ $nr_csum_no_found -eq $new_csum_no_found -a \
+	     $nr_csum_failed -eq $new_csum_failed ]; then
+		return 0
+	fi
+	return 1
+}
+$XFS_IO_PROG -f -c "falloc 0 1M" -c "pwrite 16k 8k" -c "fsync" \
+	$SCRATCH_MNT/foo > $seqres.full 2>&1
+$BTRFS_UTIL_PROG fi ba $SCRATCH_MNT >> $seqres.full 2>&1 || \
+	_fail "balance failed"
+_scratch_unmount
+_scratch_mount
+$XFS_IO_PROG -c "pread 0 1M" $SCRATCH_MNT/foo >> $seqres.full 2>&1 || \
+	_fail "pread failed"
+
+# This sucks but unfortunately it is the only way to be sure something didn't go
+# wrong.
+_check_csum_error || _fail "csum detected, please check dmesg"
+
+echo "Silence is golden"
+status=0 ; exit
diff --git a/tests/btrfs/015.out b/tests/btrfs/015.out
new file mode 100644
index 0000000..fee0fcf
--- /dev/null
+++ b/tests/btrfs/015.out
@@ -0,0 +1,2 @@ 
+QA output created by 015
+Silence is golden
diff --git a/tests/btrfs/group b/tests/btrfs/group
index 3a5747f..dc5bbea 100644
--- a/tests/btrfs/group
+++ b/tests/btrfs/group
@@ -17,3 +17,4 @@ 
 012 auto quick
 013 auto quick
 014 auto quick
+015 auto quick